(define (mkset x) (cons 'set x))
(define (mkseq x) (cons 'seq x))
(define (mkmap x) (cons 'map x))
(define (map2lst x) (cdr x))
(define (set2lst x) (cdr (map (lambda (x) (if (symbol? x) x
  (set2lst x))) x)))
(define (seq2lst x) (cdr (map (lambda (x) (if (symbol? x) x
  (seq2lst x))) x)))
(define (isset x) (eq? (car x) 'set))
(define (isseq x) (eq? (car x) 'seq))
(define (ismap x) (eq? (car x) 'map))
(display ".")
(define (prt2 x) (cond ((vector? x) (let ((n (vector-length x)) (i 1))
                                  (display "< ")
                                  (do ()
                                   ((>= i n))
                                    (prt2 (vector-ref x i))
                                    (set! i (+ i 1))
                                    (if (< i n) (display " , ")) )
                                  (display " >")
                                  (newline) ))
                     ((string? x) (display (string-append (string #\")
                                    x (string #\"))))
                     ((procedure? x) (display "object"))
                     ((not (list? x)) (if (eq? x #t) 
                                      (display (downcase "true"))
                                      (if (eq? x #f)
                                      (display (downcase "false"))
                                      (if (equal? x "&") (display " ")
                                      (display x)))))  
                     ((isset x) (let ((u '())) (display "{") ; was prin1
                                  (set! u (cdr x))
                                   (do ()
                                     ((null? u))
                                     (prt2 (car u))
                                     (set! u (cdr u))
                                     (if (not (null? u)) (display ",")) )
                                  (display "}") ))
                     ((isseq x) (let ((u '())) (display "[")
                                  (set! u (cdr x))
                                   (do ()
                                    ((null? u))
                                    (prt2 (car u))
                                    (set! u (cdr u))
                                    (if (not (null? u)) (display ",")) ) 
                                  (display "]") ))
                     ((ismap x) (let ((u '())) (display "{")
                                  (set! u (cdr x))
                                   (do ()
                                     ((null? u))
                                     (prt2 (caar u))
                                     (display "->")
                                     (prt2 (cadar u))
                                     (set! u (cdr u))
                                     (if (not (null? u)) (display ",")) ) 
                                   (display "}") ))
                     ((pair? x) (let ((u '())) (display "(")
                                  (set! u x)
                                   (do ()
                                     ((null? u))
                                     (prt2 (car u))
                                     (set! u (cdr u))
                                     (if (not (null? u)) (display ",")) )  
                                  (display ")") ))
                     (else (err2 "Unknown type" x))))
(display ".") 
(define (prt x) (prt2 x) (display " ") (newline))
(define (prf2 x f) (cond ((vector? x) (let ((n (vector-length x)) (i 1))
                                  (display "< " f)
                                  (do ()
                                   ((>= i n))
                                    (prf2 (vector-ref x i) f)
                                    (set! i (+ i 1))
                                    (if (< i n) (display " , ")) )
                                  (display " >" f)
                                  (newline f) ))
                     ((string? x) (display (string-append (string #\")
                                    x (string #\")) f))
                     ((procedure? x) (display "object" f))
                     ((not (list? x)) (if (eq? x #t) 
                                      (display (downcase "true") f)
                                      (if (eq? x #f)
                                      (display (downcase "false") f)
                                      (if (equal? x "&") (display " " f)
                                      (display x f)))))  
                     ((isset x) (let ((u '())) (display "{" f) ; was prin1
                                  (set! u (cdr x))
                                   (do ()
                                     ((null? u))
                                     (prf2 (car u) f)
                                     (set! u (cdr u))
                                     (if (not (null? u)) (display "," f)) )
                                  (display "}" f) ))
                     ((isseq x) (let ((u '())) (display "[" f)
                                  (set! u (cdr x))
                                   (do ()
                                    ((null? u))
                                    (prf2 (car u) f)
                                    (set! u (cdr u))
                                    (if (not (null? u)) (display "," f)) ) 
                                  (display "]" f) ))
                     ((ismap x) (let ((u '())) (display "{" f)
                                  (set! u (cdr x))
                                   (do ()
                                     ((null? u))
                                     (prf2 (caar u) f)
                                     (display "->" f)
                                     (prf2 (cadar u) f)
                                     (set! u (cdr u))
                                     (if (not (null? u)) (display "," f)) ) 
                                   (display "}" f) ))
                     ((pair? x) (let ((u '())) (display "(" f)
                                  (set! u x)
                                   (do ()
                                     ((null? u))
                                     (prf2 (car u) f)
                                     (set! u (cdr u))
                                     (if (not (null? u)) (display "," f)) )  
                                  (display ")" f) ))
                     (else (err2 "Unknown type" x))))
(display ".") 
(define (prf x f) (prf2 x f) (display " " f) (newline f))
(define (in2 x y) (cond ((null? y) #f)
  ((equal? (car y) x) #t)
  (else (in2 x (cdr y)))))
(define (in x y) (in2 x (cdr y)))
(define (notin x y) (not (in x y)))
(define (filter p x) (cond ((null? x) '())
  ((p (car x)) (cons (car x) (filter p (cdr x))))
  (else (filter p (cdr x)))))
(define (implies x y) (or (not x) y))
(define (equiv x y) (and (implies x y) (implies y x)))
(define (hd x) (cond ((string? x) (string (string-ref x 0)))
                     ((not (and (pair? x) (isseq x))) (err3 "not a sequence"))
                     (else (cadr x))))
(define (tl2 x) (cdr x))                                    ; tail of sequence
(define (tl x) (cond ((string? x) (substring x 1 (string-length x)))
                     ((not (and (pair? x) (isseq x))) (err3 "not a sequence"))
                     (else (mkseq (tl2 (cdr x))))))
(define (conc2 x y) (append x y))
(display ".")
(define (conc x y)
 (cond ((and (string? x) (string? y)) (string-append x y))
       ((not (and (pair? x) (isseq x))) (err3 "first operand not a sequence"))
       ((not (and (pair? y) (isseq y))) (err3 "second operand not a sequence"))
       (else (mkseq (conc2 (cdr x) (cdr y))))))
(define (itok2 j k) (let ((n '()) (v '())) (set! n j)         ; set or sequence
   (do ()
    ((not (<= n k)))
    (set! v (append v (unit n)))
    (set! n (+ n 1)) )
  v ))
(define (itokset j k) (mkset (itok2 j k)))
(define (itokseq j k) (mkseq (itok2 j k)))
(define (union2 a b) (append a (filter (lambda (x)        ; set union
  (not (in2 x a))) b)))
(define (union a b)
  (cond ((not (and (pair? a) (isset a))) (err3 "first operand not a set"))
        ((not (and (pair? b) (isset b))) (err3 "second operand not a set"))
        (else (let ((x (union2 (cdr a) (cdr b))))
           (mkset x) ))))
(define (inter2 a b) (filter (lambda (x) (in2 x b)) a))    ; set intersection
(define (inter a b)
 (cond ((not (and (pair? a) (isset a))) (err3 "first operand not a set"))
       ((not (and (pair? b) (isset b))) (err3 "second operand not a set"))
       (else (let ((x (inter2 (cdr a) (cdr b)))) (mkset x) ))))
(define (diff2 a b) (filter (lambda (x)                   ; set difference
  (not (in2 x b))) a))
(display ".")
(define (diff a b)
  (cond ((not (and (pair? a) (isset a))) (err3 "first operand not a set"))
        ((not (and (pair? b) (isset b))) (err3 "second operand not a set"))
        (else (let ((x (diff2 (cdr a) (cdr b)))) (mkset x) ))))
(define (dunion x) (let ((y '()))
 (if (not (isset x)) (err3 "not a set"))
 (set! y (cdr x))
  (do ()
   ((null? y))
   (if (not (isset (car y))) (err3 "not a set"))
   (set! y (cdr y)) )
 (set! y (cdr x))
 (mkset (dunion2 (map cdr y))) ))
(display ".")
(define (dunion2 x) (if (null? x) '()
  (union2 (car x) (dunion2 (cdr x)))))
(define (dconc2 x) (if (null? x) '() (conc2 (car x) (dconc2 (cdr x)))))
(define (dconc x) (dconc2 (cdr x)))
(define (subset2 a b) (let ((x '()) (u '()))
     (call/cc (lambda (return)
     (set! u a)
      (do ()
       (#f)
       (if (null? u) (return #t))
       (set! x (car u))
       (if (not (in2 x b)) (return #f))
       (set! u (cdr u)) ) ))))
(define (subset a b)
 (cond ((not (and (pair? a) (isset a))) (err3 "first operand not a set"))
       ((not (and (pair? b) (isset b))) (err3 "second operand not a set"))
       (else (subset2 (cdr a) (cdr b)))))
(define (elimdup x) (cond ((null? x) '())
  ((in2 (car x) (cdr x)) (elimdup (cdr x)))
  (else (cons (car x) (elimdup (cdr x))))))
(define (dom x)
 (cond ((and (pair? x) (isset x) (null? (cdr x))) x)
       ((and (pair? x) (ismap x)) (mkset (elimdup (map car (cdr x)))))
       ((and (pair? x) (isseq x)) (mkset (itok2 1 (length (cdr x)))))
       (else (err3 "improper operand"))))
(display ".")
(define (rng2 x) (if (pair? (car x))   
                   (elimdup (map cadr x))
                   (elimdup x)))
(define (rng x)
 (cond ((and (pair? x) (isset x) (null? (cdr x))) x)
       ((and (pair? x) (ismap x)) (mkset (elimdup (map cadr (cdr x)))))
       ((and (pair? x) (isseq x)) (mkset (elimdup (cdr x))))
       (else (err3 "improper operand"))))
(define (dr2 r s) (filter (lambda (x) (in2 (car x) s)) r)) ; domain restrn
(define (dr r s)
 (cond ((not (and (pair? r) (ismap r))) (err3 "first operand not a map"))
       ((not (and (pair? s) (isset s))) (err3 "second operand not a set"))
       (else (mkmap (dr2 (cdr r) (cdr s))))))
(define (ds2 r s) (filter (lambda (x) (not (in2 (car x) s))) r))
(define (ds r s)
 (cond ((not (and (pair? r) (ismap r))) (err3 "first operand not a map"))
       ((not (and (pair? s) (isset s))) (err3 "second operand not a set"))
       (else (mkmap (ds2 (cdr r) (cdr s))))))
(define (unit x) (cons x '()))      ; make singleton set
(define (card s) (if (not (and (pair? s) (isset s)))
  (err3 "not a set") (length (cdr s))))
(define (len s) (cond ((string? s) (string-length s))
                      ((not (and (pair? s) (isseq s))) (err3 "not a sequence"))
                      (else (length (cdr s)))))
(display ".")
(define (butlast2 x) (cond ((null? x) '())           ; first n-1 items of
                         ((null? (cdr x)) '())             ; sequence
                         (else (cons (car x) (butlast2 (cdr x))))))
(define (butlast x) (cond ((string? x) (substring x 0 (- (string-length x) 1)))
                          ((not (and (pair? x) (isseq x)))
                                (err3 "not a sequence"))
                          (else (mkseq (butlast2 (cdr x))))))
(define (last2 s) (if (null? (cdr s)) s (last2 (cdr s))))
(define (last s) (cond ((string? s) (if (string=? s "") (err3 "empty string")
                                    (substring s (- (string-length s) 1)
                                          (string-length s)  )))
                       ((not (isseq s)) (err3 "not a sequence"))
                       (else (mkseq (last2 (cdr s))))))
(define (the2 s) (if (= (length s) 1) (car s)               ; element of
                      (err3 "not singleton set")))
(define (the s) (if (not (and (pair? s) (isset s)))
  (err3 "not a set") (the2 (cdr s))))
(define (oneof x) (if (not (and (pair? x) (isset x)))
  (err3 "not a set") (cadr x)))
(define (first x) (if (not (pair? x)) (err3 "not an ordered pair")
  (car x)))
(define (second x) (if (not (pair? x))
  (err3 "not an ordered pair") (cadr x)))
(define (third x) (if (not (and (pair? x) (isseq x)))
  (err3 "not a sequence") (cadddr x)))
(define (eqtest2 x y) (cond ((null? x) #t)
  ((not (member (car x) y)) #f)
  (else (eqtest2 (cdr x) y))))
(display ".")
(define (eqtest x y) (if (not (= (length x) (length y))) #f
  (eqtest2 x y)))
(define (neqtest2 x y) (not (eqtest2 x y)))
(define (neqtest x y) (if (not (= (length x) (length y))) #t
  (neqtest2 x y)))
(define (asm2 x n) (if (null? x) '()
  (cons (list n (car x)) (asm2 (cdr x) (+ n 1)))))
(define (asm x) (if (not (and (pair? x) (isseq x)))
  (err3 "not a sequence") (mkmap (asm2 (cdr x) 1))))
(define (asq2 x) (let ((y (map car x)))
 (if (not (equal? (itok2 1 (length x)) y)) (err3 "not a proper map")
 (map cadr x))))
(define (asq x) (if (not (and (pair? x) (ismap x)))
  (err3 "not a map") (mkseq (asq2 (cdr x)))))
(define (im2 r s) (rng2 (dr2 r s)))                  ; image of a set
(define (im r s)
 (cond ((not (and (pair? r) (ismap r))) (err3 "first operand not a map"))
       ((not (and (pair? s) (isset s))) (err3 "second operand not a set"))
       (else (mkset (im2 (cdr r) (cdr s))))))
(define (inverse2 r) (map (lambda (x)                  ; inverse of map
                     (list (cadr x) (car x))) r))
(define (inverse r) (cond ((and (pair? r) (isset r) (null? (cdr r)))
                                r)
                          ((not (and (pair? r) (ismap r)))
                                (err3 "not a map"))
                          (else (mkmap (inverse2 (cdr r))))))
(define (doappend x y) (mkmap (append (cdr x) (cdr y))))
(display ".")
(define (overwr2 f g) (doappend (ds f (dom g)) g))
(define (overwr f g) (call/cc (lambda (return)
  (if (and (pair? f) (isset f) (null? (cdr f))
           (pair? g) (isset g) (null? (cdr g))) (return (mkset '())))
  (if (and (pair? f) (isset f) (null? (cdr f))) (return g))
  (if (and (pair? g) (isset g) (null? (cdr g))) (return f))
  (return (overwr2 f g)) )))
