(define flag #f)
(define @true #t)
(define @false #f)
(define @eof #f)              
(define filef #f)
(define locals '())
(define subcl #f)
(define super '())
(define *catchers* #f)
(define (mbr x y) (cond ((null? y) '())
                        ((eq? (caar y) x) y)
                        (else (mbr x (cdr y)))))
(define (search x y) (cond ((null? y) '())                 ; used to search
                           ((eq? x (caar y)) (cdar y))     ; inheritance list
                           (else (search x (cdr y)))))
(define (srch x y) (cond ((null? y) #f)
                         ((eq? x (caar y)) #t)
                         (else (srch x (cdr y))))) 
(define (repl x y) (cons (car y) (cons (cadr y) (cons x (cddr y)))))
(define (downcase s) (let ((l (string->list s)))
 (list->string (map (lambda (c) (let ((i (char->integer c)))
  (if (and (>= i 65) (<= i 90)) (integer->char (+ i 32)) c) )) l)) ))
(define (print x) (display x) (newline))
(define gensym (let ((n 0)) (lambda ()
  (set! n (+ n 1)) 
  (string->symbol (string-append "G00" (number->string n))))))
(define (file2str fname) (let ((char #f) (str #f) (p (open-input-file fname)))
  (call/cc (lambda (return)
  (if (null? p) (print 'file-not-known))
  (set! char (read-char p))
  (set! str (string char))
   (do ()
    (#f)
    (set! char (read-char p))
    (if (eof-object? char) (return str))
    (if (eq? char #\newline) (set! char #\space))   ; was #\return
    (if (not (eq? char #\newline))
    (set! str (string-append str (string char)))) )
  ))))
(define (delete s c) (cond ((null? c) '())
        ((eq? (caar c) (caar s)) (delete s (cdr c)))
        (else (cons (car c) (delete s (cdr c))))))
; (define (catch tag form)
; (let ((c (gensym)))
; (call/cc (lambda (c)
;  (set! *catchers* (cons (cons tag c) *catchers*)) form))))
(define-syntax catch (syntax-rules ()
  ((catch tag form ...) (let ((c (gensym)))
  (call/cc (lambda (c)
  (set! *catchers* (cons (cons tag c) *catchers*)) form ... ))) )))
(define (throw tag value)
 (let ((s (mbr tag *catchers*)))
 (cond ((null? s) (begin (display "No CATCH established for ") 
                         (display tag)))                       
       (else (set! *catchers* (cdr s))
             ((cdar s) value)))))
(define (val-of sym) (with-error-handler (lambda (m c)
  (err5 "unbound variable: " sym)) (lambda () (eval sym))))
(display ".")
(define run (lambda () (display "Proxy v1.5") (newline)
  (display "Copyright (c) 1995 Burt Leavenworth - all rights reserved")
  (newline) (newline)
  (do () (#f) (catch 'err (msg)) ))) 
(define (unit x) (cons x '()))
(define (err2 m v) (display m) (display v) (newline)   
  (display (throw 'err input)))                      
(define (err3 m) (display m) (newline) (display (throw 'err input))) 
(define err4 (lambda () (display "syntax error - ")
  (display (string-append word input))
  (newline) (display (throw 'err input))))           
(define (err5 m v) (display m)
 (display (substring (symbol->string v) 1
 (string-length (symbol->string v)))) (newline)
 (throw 'err input))
(display ".")
(define (err n) (let ((x
 (case n ((1) "missing left paren")
         ((2) "missing argument list")
         ((3) "missing right paren")
         ((4) "missing block")
         ((5) "missing class name")
         ((6) "missing {")
         ((7) "missing :")
         ((8) "missing definition list")
         ((9) "missing }")
         ((10) "missing function name")
         ((11) "missing name")
         ((12) "missing expression")
         ((13) "missing record name")
         ((14) "missing name list")
         ((15) "missing ]")
         ((16) "missing =")                 
         ((17) "missing selector")
         ((18) "missing statement list")
         ((19) "missing ;")
         ((20) "missing statement")
         ((21) "missing name/value list")
         ((22) "missing identifier")
         ((23) "missing relational operand")
         ((24) "missing term")
         ((25) "missing factor")
         ((26) "missing ->")
         ((27) "missing pair element")
         ((28) "missing pair")
         ((29) "function not defined")
         ((30) "name not defined")
         ((31) "missing in")
         ((32) "missing <-")
         ((33) "missing pair list")
         ((34) "missing ..")
         ((35) "incorrect filename")        
         ((36) "public keyword missing")  
         ((37) "missing file mode")       
         ((38) "file not defined")        
         ((39) "wrong length")            
         ((40) "file name not string") ))) 
  (display x) (newline)
  (display (throw 'err input))             
))
(display ".")
(define (isfalse x) (equal? '$false x))       ; was eq?
(define isfun (lambda () (let ((i 0) (n (- (string-length input) 1))
                              (p 1))
 (call/cc (lambda (return)
 (do ()                                                      ; scan
  ((not (and (char=? (string-ref input i) #\ ) (< i n))))    ; blanks
  (set! i (+ i 1)) )
 (if (not (char=? (string-ref input i) #\()) (return #f))  ; if not (
 (set! i (+ i 1))
  (do ()
   ((not (and (not (= p 0)) (< i n))))
   (if (char=? (string-ref input i) #\( ) (set! p (+ p 1)))
   (if (char=? (string-ref input i) #\) ) (set! p (- p 1)))
   (set! i (+ i 1)) )
  (do ()                                                      ; scan
   ((not (and (char=? (string-ref input i) #\ ) (< i n))))    ; blanks
   (set! i (+ i 1)) )
  (if (char=? (string-ref input i) #\{) (return #t))
 (return #f) )))))
(define (lookrec x y) (cond ((null? y) (err2 "selector not found -  "
  (downcase (substring (symbol->string x)    ; was string->symbol
   1 (string-length (symbol->string x)))) ))
  ((equal? (caar y) x) (cadar y))
  (else (lookrec x (cdr y)))))
(display ".")
(define (casef x) (let ((u '()) (n '()) (y '())) 
     (call/cc (lambda (return)
     (set! n 1)
     (set! u x)
     (do ()
      (#f)
      (if (null? u) (return y))
      (set! y (append y (list (list (car u) n))))
      (set! u (cdr u))
      (set! n (+ n 1)) )
      ))))
(define (app m x) (cond ((null? m) '())
  ((equal? (caar m) x) (cadar m))
  (else (app (cdr m) x))))
(define (sel x n) (cond ((or (< n 1) (> n (length x)))
  '())
  ((= n 1) (car x))
  (else (sel (cdr x) (- n 1)))))
(define (seld x n d) (cond ((or (< n 1) (> n (length x))) d)
  ((= n 1) (car x))
  (else (seld (cdr x) (- n 1) d))))
(define (appd m x d) (cond ((null? m) d)
  ((equal? (caar m) x) (cadar m))
  (else (appd (cdr m) x d))))
(display ".")
(define deflist (lambda () (let ((ls '()) (target '())) 
  (call/cc (lambda (return)
 (set! target (fundef))
 (if (isfalse target) (return ls))
 (set! target `(,(car target) (lambda ,(cadr target)
   (call/cc (lambda (return) ,(caddr target) )))))
 (set! ls (append ls (unit target)))
  (do ()
   (#f)
   (set! target (fundef))
     (if (isfalse target) (return ls))
   (set! target `(,(car target) (lambda ,(cadr target)
    (call/cc (lambda (return) ,(caddr target) )))))
   (set! ls (append ls (unit target))) ) 
 )))))
(display ".")
(define fundef (lambda () (let ((target '()) (target2 '())
   (target3 '()) (target4 '())) (call/cc (lambda (return)
 (if (not (symbol? word)) (return '$false))
 (set! target word)
 (set! word (next))
 (if (not (equal? word "(")) (err4))
 (set! word (next))
 (if (equal? word ")") (begin
  (set! target2 '())
  (set! word (next)) ) (begin
  (if (equal? word ";") (begin
    (set! word (next))
    (set! target4 (idenlist))
    (if (isfalse target4) (err4)) ) (begin
  (set! target2 (arglistu))
  (if (isfalse target2) (err4))
  (if (equal? word ";") (begin
    (set! word (next))
    (set! target4 (idenlist))
    (if (isfalse target4) (err4)) )) ))
  (if (not (equal? word ")")) (err4))
  (set! word (next)) ))
(if (not (equal? word "{")) (err4))
(set! word (next))
(set! target3 (stmtlst))
(if (isfalse target) (err4))
(if (not (equal? word "}")) (err4))
(set! word (next))
(set! target3 (append target3 (list '(return (string->symbol " ")))))
  (if (isfalse target3) (err4))
  (string->symbol " ")
(display " ")
(display (downcase (substring (symbol->string target) 1
  (string-length (symbol->string target)))))
(newline)
(if (null? target4) (return (list target target2 target3))
 (return (list target target2 (list 'let
   (map (lambda (x) (list x (quote '()))) target4) target3)))) )) ))) 
(display ".")
(define (upds2 s ind v) (cond ((> ind (length s)) ; update sequence element
                                  (err2 "index out of range - " ind))
                              ((= ind 1) (cons v (cdr s)))
                              (else (cons (car s) (upds2 (cdr s)
                              (- ind 1) v)))))
(define (upds s ind v) (if (< ind 1) (err2 "index out of range - " ind)
                       (mkseq (upds2 (cdr s) ind v))))
(define menu (lambda () (let ((target 0)) (newline)
  (do ()
   ((= target 9))
   (display (string-append "1 commands 2 functions 3 statements 4 sets "
               "5 maps 6 sequences")) (newline)
   (display " 7 structs 8 classes 9 quit") (newline)
   (set! target (read))
   (case target
     ((1) (system "more h1.hlp"))
     ((2) (system "more h2.hlp"))
     ((3) (system "more h3.hlp"))
     ((4) (system "more h4.hlp"))
     ((5) (system "more h5.hlp"))
     ((6) (system "more h6.hlp"))
     ((7) (system "more h7.hlp"))
     ((8) (system "more h8.hlp")) ))
  (read-line #f)
  #t)))
(display ".")
(define msg (lambda () (let ((target '()) (target2 '()) (target3 '()) 
 (target4 '()) (target5 '()) (target6 '()) (target7 '())
 (target8 '()) (casel '()) (casem '()) (ch '()))
 (call/cc (lambda (return)
 (clear)
 (set! word (next))
 (newline)
 (if (equal? word '@exit) (exit))                           ; exit
 (if (equal? word '@load) (begin                            ; load
   (set! target (next))
   (if (not (string? target)) (err 40))
   (set! fp (open-input-file target ))                                                              ; UPGRADE
   (if (null? fp) (err 35))
   (set! input "")
   (set! filef #t)
   (return #t) ))
 (if (equal? word '@end) (begin                             ; end
  (set! filef #f)
  (close-input-port fp)
  (return #t) ))
 (if (equal? word '@struct) (begin                          ; structure
   (set! word (next))                                       ; declaration
   (if (not (symbol? word)) (err4))
   (set! target word)
   (set! word (next))
   (if (not (equal? word "{")) (err4))
   (set! word (next))
   (set! target2 (casef (idenlist)))        
   (if (isfalse target2) (err4))
   (eval `(set! ,target ',target2))         
   (if (not (equal? word ";")) (err4))
   (set! word (next))
   (if (not (equal? word "}")) (err4))
   (display (downcase (substring (symbol->string target)  
    1 (string-length (symbol->string target)))))         
   (newline)                                    
   (return #t) ))
 (if (equal? word '@class) (begin                           ; class
   (set! word (next))
   (if (not (symbol? word)) (err4))
   (set! target word)
   (set! word (next))
   (if (not (equal? word "(")) (err4))
   (set! word (next))
   (if (equal? word ")") (begin
    (set! word (next))
    (set! target2 '()) ) (begin
    (if (equal? word ";") (begin            
    (set! word (next))                     
    (set! target5 (idenlist)) 
    (if (isfalse target5) (err4)) ) (begin   
    (set! target2 (idenlist))               ; was arglistu
    (if (isfalse target2) (err4))          
    (if (equal? word ";") (begin          
    (set! word (next))                   
    (set! target5 (idenlist))  
    (if (isfalse target5) (err4)) )) ))   
    (if (not (equal? word ")")) (err4))
    (set! word (next)) ))
   (if (equal? word ":") (begin
    (set! target6 (next))
    (if (not (symbol? target6)) (err4))
    (set! word (next))                  
    (set! subcl #t) ))                 
   (if (not (equal? word "{")) (err4))
   (set! word (next))
   (set! target3 (deflist))
   (if (isfalse target3) (err4))
 (set! target7 (map (lambda (x) (list (unit (car x)) (car x))) target3))
 (set! target7 (append target7
 (unit '(else (err2 "unknown msg - " (downcase (substring ; was string->symbol
     (symbol->string m) 1 (string-length
     (symbol->string m)) ))))) ))
(set! target7 (list 'define target (list 'lambda target2 (list 'let
 (map (lambda (x) (list x (quote '()))) target5) (list 'letrec target3
  (list 'lambda '(m) (append (list 'case 'm) target7)))))))
 (if subcl
(let ((res (search target6 super)))
 (if res (begin (set! target6 (cadr (caddr (caddr (caddr (car res))))))
 (set! target8 (cadr (caddr (caddr (car res)))))
 (set! target5 (map (lambda (x) (list x (quote '()))) target5))   
 (set! target8 (elimdup (append target5 target8)))     
 (set! target4 (map (lambda (x) (list (unit (car x)) (car x))) target6))
  (set! casel target3)
  (for-each (lambda (x) (if (not (srch (car x) target3)) 
  (set! casel (cons x casel))  )) target6)
  (set-car! (cdr (caddr (caddr (caddr target7)))) casel)
  (set-car! (cdr (caddr (caddr target7))) target8)
  (set! casem (caddr (caddr (caddr (caddr (caddr target7))))))
  (do ()
   ((null? target4))
   (set! casem (repl (car target4) casem))
   (set! target4 (cdr target4)) )
  (set-car! (cddr (caddr (caddr (caddr (caddr target7))))) casem)
  (set! subcl #f)) (err2 "base class not found: "
  (downcase (substring (symbol->string target6) 1 (string-length 
    (symbol->string target6)) )) ))))                          
  (set! super (cons (list target target7) super))              
 (set! target (eval target7))
 (set! target (car target))
       (if (not (equal? word "}")) (err 9))
       (set! word (next))
  (display (downcase (substring (symbol->string target) 1 
    (string-length (symbol->string target)) )))          
       (newline)
       (return #t) ))
 (if (equal? word '@help) (begin
   (set! word (next))
   (if (not (equal? word ";")) (err4))
   (return (menu)) ))
 (if (equal? word '@transcript) (begin
   (set! target (next))
   (if (not (string? target)) (err 40))
   (transcript-on target)
   (set! word (next))
   (return #t) ))
 (if (equal? word '@shell) (begin          
   (set! target (next))                   
   (if (not (string? target)) (err4))     
   (set! word (next))                     
   (if (not (equal? word ";")) (err4))    
   (system  target)                       
   (return #t) ))                        
 (if (symbol? word) (begin
   (if (isfun) (begin
    (set! target word)
    (set! word (next))
    (set! word (next))
(if (equal? word ")") (begin
    (set! target2 '())
    (set! word (next)) ) (begin
    (if (equal? word ";") (begin
    (set! word (next))
    (set! target4 (idenlist))
    (if (isfalse target4) (err4)) ) (begin
    (set! target2 (arglistu))
  (if (isfalse target2) (err4))
  (if (equal? word ";") (begin
    (set! word (next))
    (set! target4 (idenlist))
    (if (isfalse target4) (err4)) )) ))
    (if (not (equal? word ")")) (err4))
    (set! word (next)) ))
    (set! locals target4)
    (set! target4 (map (lambda (x) (list x (quote '()))) target4))  
    (if (not (equal? word "{")) (err4))
    (set! word (next))
    (set! target3 (stmtlst))
    (if (isfalse target3) (err4))
    (if (not (equal? word "}")) (err4))
    (set! word (next))
    (set! target3 (append target3 (list '(return (string->symbol " ")))))
      (if (isfalse target3) (err 4))
 ;  (print `(define ,target (lambda ,target2 (let ,target4
 ;     ,target3))))
     (set! target (eval `(define ,target (lambda ,target2 (let ,target4
     (call/cc (lambda (return) ,target3))))))); function defn
  (display (downcase (substring (symbol->string (car target)) 
     1 (string-length (symbol->string (car target))))))      
      (newline)
      (return #t) ))
(if (lookmpu) (begin
    (set! target word)
    (set! word (next))
    (set! word (next))
    (set! target2 (expr))                              ; map update
    (if (isfalse target2) (err4))
    (if (not (equal? word "]")) (err4))
    (set! word (next))
    (if (not (equal? word "=")) (err4))
    (set! word (next))
    (set! target3 (expr))
    (if (isfalse target3) (err4))
    (if (null? (cdr (eval target)))
     (eval `(set! ,target (mkmap '()))))
    (if (isseq (eval target)) (begin (eval `(set! ,target     
      (upds (eval ,target) ,target2 ,target3)))
      (return #t) ))                          
    (eval `(set! ,target (overwr ,target (mkmap (list (list
      ,target2 ,target3))))))      
    (return #t) ))
   (if (lookrcu) (begin
    (set! target word)
    (set! word (next))
    (set! word (next))
    (set! target2 word)
    (set! word (next))
   (if (vector? (eval target)) (begin
   (set! target3 (vector-ref (eval target) 0))
   (set! target3 (lookrec target2 (eval target3)))
   (if (equal? word "=") (begin
     (set! word (next))                                    ; record update
     (set! target4 (expr))
     (if (isfalse target4) (err4))
     (vector-set! (eval target) target3 target4)
     (return #t) )) )) ))
   (if (and (lookahead #\=) (not (lookahead2 #\= #\=))) (begin
     (set! target word)
     (if (not (symbol? target)) (err4))
     (set! word (next))
     (set! word (next))
     (set! target2 (expr))
     (if (isfalse target2) (err4))
     (eval `(set! ,target ',target2))                     ; assign
     (display (downcase (substring (symbol->string target) 
      1 (string-length (symbol->string target)))))        
     (newline)                                                 
     (return #t) )) ))
   (set! target (expr))
   (if (isfalse target) (return #f))
   (prt target)
   (return #t) )))))
(display ".")
(define block (lambda () (let ((target '()) (target2 '())) 
 (call/cc (lambda (return)
 (if (not (equal? word "{")) (return '$false))
 (set! word (next))
 (set! target (stmtlst))
 (if (isfalse target) (err4))
 (if (not (equal? word "}")) (err4))
 (set! word (next))
 (return target) )) )))
(define stmtlst (lambda () (let ((target '()) (ls '())) 
 (call/cc (lambda (return)
 (set! target (simstmt))
 (if (isfalse target) (return '$false))
 (if (pair? (car target)) (for-each (lambda (i) (set! ls  
 (append ls (list i)))) target)                          
 (set! ls (append ls (list target))) )
 (set! target (simstmt))
  (do ()
   (#f)
   (if (isfalse target) (return (cons 'begin ls)))
   (if (pair? (car target)) (for-each (lambda (i) (set! ls
    (append ls (list i)))) target)
   (set! ls (append ls (list target))) )
   (set! target (simstmt))
  )
  )))))
(display ".")
(define stmt (lambda () (let ((target '())) (call/cc (lambda (return)
 (set! target (simstmt))
 (if (not (isfalse target)) (return target))
 (set! target (block))
 (if (not (isfalse target)) (return target))
 (return '$false) )))))
(define simstmt (lambda ()
  (let ((target '()) (target2 '()) (target3 '()) (target4 '()) (ls '()))
 (call/cc (lambda (return)
 (if (equal? word ";")
     (set! word (next)) )
 (if (equal? word "&") (begin
     (set! word (next))
     (return (list 'string->symbol " ")) ))
 (if (equal? word '@return) (begin
     (set! word (next))                              ; return state
     (if (equal? word ";") (begin
       (set! word (next))
       (return (list 'return (list 'string->symbol " "))) ))
     (set! target (expru))
     (if (not (equal? word ";")) (err4))
     (set! word (next))
     (return (list 'return target)) ))
 (if (equal? word '@if) (begin
     (set! word (next))
     (if (not (equal? word "(")) (err4))             ; if state
     (set! word (next))
     (set! target (expru))
     (if (isfalse target) (err4))
     (if (not (equal? word ")")) (err4))
     (set! word (next))
     (set! target2 (stmt))
     (if (isfalse target2) (err4))
     (if (not (equal? word '@else))
       (return (list 'if target target2)) )
     (set! word (next))
     (set! target3 (stmt))
     (if (isfalse target3) (err4))
     (return (list 'if target target2 target3)) ))
 (if (equal? word '@while) (begin
     (set! word (next))
     (if (not (equal? word "(")) (err4))              ; while state
     (set! word (next))
     (set! target (expru))
     (if (not (equal? word ")")) (err4))
     (set! word (next))
     (set! target2 (stmt))
     (if (isfalse target2) (err4))
     (return (list 'while target target2)) ))
  (if (equal? word '@print) (begin                          
     (set! word (next))                                    
     (set! target (expru))
     (if (isfalse target) (err 12))
     (if (not (equal? word ";")) (err 19))
     (set! word (next))
     (return (list 'prt target)) ))
  (if (equal? word '@fprint) (begin
    (set! word (next))
    (if (not (equal? word "(")) (err4))
    (set! word (next))
    (if (not (symbol? word)) (err 12))
    (set! target word)
    (set! word (next))
    (if (not (equal? word ",")) (err4))
    (set! word (next))
    (set! target2 (expru))
    (if (isfalse target2) (err 12))
    (if (not (equal? word ")")) (err4))
    (set! word (next))
    (if (not (equal? word ";")) (err4))
    (set! word (next))
    (return (list 'prf target2 target)) )) 
 (if (equal? word '@close) (begin
   (set! word (next))
   (if (not (equal? word "(")) (err 1))
   (set! target (next))
   (set! word (next))
   (if (not (equal? word ")")) (err 3))
   (set! word (next))
   (if (not (equal? word ";")) (err 19))
   (set! word (next))
   (return `(call/cc (lambda (return)
   (if (not (output-port? ,target)) (err 38))
   (return (close-output-port ,target)) )) )) )
 (if (equal? word '@exit) (begin
   (set! word (next))
   (if (not (equal? word ";")) (err4))
   (set! word (next))
   (return '(err3 "program end")) ))
 (if (equal? word '@scan) (begin
   (set! word (next))
   (set! target4 input)
   (set! target word)
   (if (isfalse target) (err4))
   (set! word (next))
   (if (not (equal? word ";")) (err4))
   (return `(let ((target2 '()) (target3 '()) (target4 '()))
   (set! target4 ',target4)
   (set! target ',target)
   (set! target2 (read-line #f))
   (set! input (string-append target2 target4 ";"))
   (set! word (next))
   (set! target3 (expr)) 
   (set! ,target target3) )) ))
 (if (equal? word '@fscan) (begin
   (set! word (next))
   (set! target4 input)
   (if (not (equal? word "(")) (err4))
   (set! word (next))
   (set! target word)                  ; file pointer
   (set! word (next))
   (if (not (equal? word ",")) (err4))
   (set! word (next))
   (set! target5 word)                 ; variable
   (if (not (symbol? word)) (err4))
   (set! word (next))
   (if (not (equal? word ")")) (err4))
   (set! word (next))
   (if (not (equal? word ";")) (err4))
   (return `(let ((target2 '()) (target3 '()) (target4 '()) (target5 '()))
   (set! target4 ',target4)
   (set! target5 ',target5)
   (set! target ',target)
   (set! filef #t)
   (set! target2 (read-line ,target))   ; read only a single line of file
   (set! filef #f)
   (set! input (string-append target2 target4 ";"))
   (set! word (next))
   (set! target3 (factor))
   (set! ,target5 target3) )) ))  
 (if (symbol? word) (begin
   (set! target word)
   (set! word (next))
   (if (equal? word "=") (begin                           ; assign state
     (set! word (next))
     (set! target2 (expru))
     (if (isfalse target2) (err4))
     (if (not (equal? word ";")) (err4))
     (set! word (next))
     (return (list 'set! target target2)) ))
   (if (equal? word "(") (begin
     (set! word (next))
     (if (equal? word ")") (set! target2 '())  
     (set! target2 (arglistu)) )                         ; procedure call
     (if (not (equal? word ")")) (err4))
     (set! word (next))
     (if (not (equal? word ";")) (err4))
     (set! word (next))
     (return (cons target target2)) ))
   (if (equal? word "[") (begin
     (set! word (next))
     (set! target2 (expru))
     (if (isfalse target2) (err4))
     (if (not (equal? word "]")) (err4))                ; map update
     (set! word (next))
     (if (not (equal? word "=")) (err4))
     (set! word (next))
     (set! target3 (expru))
     (if (not (equal? word ";")) (err4))
     (set! word (next))
    (return `(call/cc (lambda (return) (if (null? (cdr ,target))
      (set! ,target (mkmap '())))
      (return (set! ,target (overwr ,target (mkmap
       (list (list ,target2 ,target3)))))) )) )) )))
  (if (equal? word ".") (begin
  (set! word (next))
  (set! target2 word)
  (set! word (next))
   (if (equal? word "=") (begin
     (set! word (next))                                    ; record update
     (set! target4 (expru))
     (if (isfalse target4) (err4))
     (if (not (equal? word ";")) (err4))
     (set! word (next))
   (return `(call/cc (lambda (return) (return (vector-set! ,target
   (lookrec (quote ,target2)
   (eval (vector-ref ,target 0))) ,target4)))) )))
  (if (equal? word "(") (begin
   (set! word (next))
   (if (equal? word ")") (begin
     (set! word (next))
     (set! target3 '())) (begin
       (set! target3 (arglistu))
       (if (isfalse target3) (err4))
       (if (not (equal? word ")")) (err4))
       (set! word (next)) )) ))
   (if (not (equal? word ";")) (err4))
   (set! word (next))
   (return `(call/cc (lambda (return)
     (return ((,target (quote ,target2)) ,@target3))))) ))
   (return '$false) )))))
(display ".")
(define (div x y) (/ (+ x 0.0) (+ y 0.0)))
(define (lt x y) (if (and (string? x) (string? y))
  (string<? x y) (< x y)))
(define (eq x y) (if (and (string? x) (string? y))
  (string=? x y) (equal? x y)))
(define (gt x y) (if (and (string? x) (string? y))
  (string>? x y) (> x y)))
(define (le x y) (if (and (string? x) (string? y))
  (string<=? x y) (<= x y)))
(define (ge x y) (if (and (string? x) (string? y))
  (string>=? x y) (>= x y)))
(define (ne x y) (if (and (string? x) (string? y))
  (neq x y) (neq x y)))                            
(define expr (lambda () (let ((target '()) (target2 '()) (target3 '()))
  (call/cc (lambda (return)
   (set! target (simple))
   (if (isfalse target) (return '$false))
   (set! target2 (relop))
   (if (isfalse target2) (return target))  
   (set! target3 (simple))
   (if (isfalse target3) (err4))
(if (and (pair? target) (isset target)
         (pair? target3) (isset target3)) (begin
  (if (equal? target2 'equal) (return (eqtest
    (cdr target) (cdr target3) )))
  (if (equal? target2 'neq) (return (neqtest
    (cdr target) (cdr target3) ))) ))
  (case target2 ('< (set! target2 lt))
                ('> (set! target2 gt))
                ('equal (set! target2 eq))
                ('<= (set! target2 le))
                ('>= (set! target2 ge))
                ('neq (set! target2 ne)) )
   (return (target2 target target3)) )) )))
(display ".")
(define idenlist (lambda () (let ((target '()) (target2 '()) (ls '()))
 (call/cc (lambda (return)
 (set! target word)                      
 (if (null? target) (return ls))        
 (set! ls (append ls (unit target)))
 (set! word (next))
  (do ()
   ((not (equal? word ",")))
   (set! word (next))
   (set! target2 word)
   (set! ls (append ls (unit target2)))
   (set! word (next)) )
 (return ls) )) )))
(define namelist (lambda () (let ((target '()) (target2 '()) (ls '()))
 (call/cc (lambda (return)
 (if (not (symbol? word)) (return ls))
 (set! ls (append ls (unit word)))
 (set! word (next))
  (do ()
   ((not (symbol? word)))
   (set! ls (append ls (unit word)))
   (set! word (next)) )
 (return ls) )) )))
(define simple (lambda () (let ((target '()) (target2 '()) (op '()))
 (call/cc (lambda (return)
 (set! target (term))
 (if (isfalse target) (return '$false))
 (set! op (addop))
  (do ()
   ((not op))
   (if (and (equal? op disj) (equal? target #t))
    (begin (set! target2 (termu)) (return #t)))
   (set! target2 (term))
   (if (isfalse target2) (err4))
   (set! target (op target target2))
   (set! op (addop)) )
(return target) )) )))
(display ".")
(define term (lambda () (let ((target '()) (target2 '()) (op '()))
 (call/cc (lambda (return)
 (set! target (factor))
 (if (isfalse target) (return '$false))
 (set! op (mulop))
  (do ()
   ((not op))
   (if (and (equal? op conj) (equal? target #f))
    (begin (set! target2 (factoru)) (return #f)))
   (set! target2 (factor))
   (if (isfalse target2) (err4))
   (set! target (op target target2))
   (set! op (mulop)) )
 (return target) )) )))
(define addop (lambda () (call/cc (lambda (return)
 (if (equal? word "+") (begin (set! word (next)) (return +)))
 (if (equal? word "-") (begin (set! word (next)) (return -)))
 (if (and (symbol? word) (equal? (symbol->string word) "@U"))
   (begin (set! word (next)) (return union)))
 (if (equal? word '@overwr) (begin (set! word (next)) (return overwr)))
 (if (equal? word '@diff) (begin (set! word (next)) (return diff)))
 (if (equal? word "||") (begin (set! word (next)) (return disj)))
 (return #f) )) ))
(define mulop (lambda () (call/cc (lambda (return)
 (if (equal? word "*") (begin (set! word (next)) (return *)))
 (if (equal? word "/") (begin (set! word (next)) (return div)))
 (if (equal? word "%") (begin (set! word (next)) (return remainder)))
 (if (equal? word '@ds) (begin (set! word (next)) (return ds)))
 (if (equal? word '@dr) (begin (set! word (next)) (return dr)))
 (if (equal? word '@im) (begin (set! word (next)) (return im)))
 (if (equal? word '@conc) (begin (set! word (next)) (return conc)))
 (if (equal? word '@inter) (begin (set! word (next)) (return inter)))
 (if (equal? word "&&") (begin (set! word (next)) (return conj)))
 (return #f) )) ))
(define addopu (lambda () (call/cc (lambda (return)
 (if (equal? word "+") (begin (set! word (next)) (return '+)))
 (if (equal? word "-") (begin (set! word (next)) (return '-)))
 (if (and (symbol? word) (equal? (symbol->string word)"@U"))
   (begin (set! word (next)) (return 'union)))
 (if (equal? word '@overwr) (begin (set! word (next)) (return 'overwr)))
 (if (equal? word '@diff) (begin (set! word (next)) (return 'diff)))
 (if (equal? word "||") (begin (set! word (next)) (return 'disj)))
 (return #f) )) ))
(define mulopu (lambda () (call/cc (lambda (return)
 (if (equal? word "*") (begin (set! word (next)) (return '*)))
 (if (equal? word "/") (begin (set! word (next)) (return 'div)))
 (if (equal? word "%") (begin (set! word (next)) (return 'remainder)))
 (if (equal? word '@ds) (begin (set! word (next)) (return 'ds)))
 (if (equal? word '@dr) (begin (set! word (next)) (return 'dr)))
 (if (equal? word '@im) (begin (set! word (next)) (return 'im)))
 (if (equal? word '@conc) (begin (set! word (next)) (return 'conc)))
 (if (equal? word '@inter) (begin (set! word (next)) (return 'inter)))
 (if (equal? word "&&") (begin (set! word (next)) (return 'conj)))
 (return #f) )) ))
(define (neq x y) (not (equal? x y)))
(define relop (lambda () (call/cc (lambda (return)         ; relop
 (if (symbol? word) (cond ((equal? word '@in)
                      (set! word (next)) (return in))
                          ((equal? word '@notin)
                      (set! word (next)) (return notin))
                          ((equal? word '@subset)
                      (set! word (next)) (return subset))
                          ((equal? word '@equiv)
                      (set! word (next)) (return equiv))
                          ((equal? word '@implies)
                      (set! word (next)) (return implies))
                      (else (return '$false))))
 (case (string->symbol word) ('== (set! word (next)) (return 'equal))
            ('!= (set! word (next)) (return 'neq))  
            ('< (set! word (next)) (return '<))
            ('<= (set! word (next)) (return '<=))
            ('>  (set! word (next)) (return '>))
            ('>= (set! word (next)) (return '>=)))
 (return '$false) )) ))
(define relopu (lambda () (call/cc (lambda (return)         ; relop
 (if (symbol? word) (cond ((equal? word '@in)
                      (set! word (next)) (return 'in))
                          ((equal? word '@notin)
                      (set! word (next)) (return 'notin))
                          ((equal? word '@subset)
                      (set! word (next)) (return 'subset))
                          ((equal? word '@equiv)
                      (set! word (next)) (return 'equiv))
                          ((equal? word '@implies)
                      (set! word (next)) (return 'implies))
                      (else (return '$false))))
 (case (string->symbol word) ('== (set! word (next)) (return 'equal))
            ('!= (set! word (next)) (return 'neq))  
            ('< (set! word (next)) (return '<))
            ('<= (set! word (next)) (return '<=))
            ('>  (set! word (next)) (return '>))
            ('>= (set! word (next)) (return '>=)))
 (return '$false) )) ))
(display ".")
(define pair (lambda () (let ((target '()) (target2 '()))
 (call/cc (lambda (return)
 (set! target (simple))
 (if (isfalse target) (return '$false))
 (if (not (equal? word "->")) (err4))
 (set! word (next))
 (set! target2 (simple))
 (if (isfalse target2) (err4))
 (return (list target target2)) )) )))
(define pairu (lambda () (let ((target '()) (target2 '()))
 (call/cc (lambda (return)
 (set! target (simpleu))
 (if (isfalse target) (return '$false))
 (if (not (equal? word "->")) (err4))
 (set! word (next))
 (set! target2 (simpleu))
 (if (isfalse target2) (err4))
 (return (list 'list target target2)) )) )))
(define pairlist (lambda () (let ((target '()) (ls '()))
 (call/cc (lambda (return)
 (set! target (pair))
 (if (isfalse target) (return '$false))
 (set! ls (unit target))
 (do ()
  ((not (equal? word ",")))
  (set! word (next))
  (set! target (pair))
  (if (isfalse target) (err4))
  (set! ls (append ls (unit target))) )
 (return ls) )) )))
(display ".")
(define pairlistu (lambda () (let ((target '()) (ls '()))
 (call/cc (lambda (return)
 (set! target (pairu))
 (if (isfalse target) (return '$false))
 (set! ls (unit target))
  (do ()
   ((not (equal? word ",")))
   (set! word (next))
   (set! target (pairu))
   (if (isfalse target) (err4))
   (set! ls (append ls (unit target))) )
 (return ls) )) )))
(define (sc pr) (let ((i '()) (n '())      ; set or sequence comprehension         
      (f '()) (p #\@)) (call/cc (lambda (return) ; argument pr is either
      (set! n (string-length input))             ; #\} or #\]
      (set! i 0)
      (if (equal? word "{") (begin (set! f 1) (set! p #\})))
      (if (equal? word "[") (begin (set! f 1) (set! p #\])))
     (do ()
      (#f)
      (if (char=? (string-ref input i) #\{) (begin (set! f 1)
                  (set! p #\})))
      (if (char=? (string-ref input i) #\[) (begin (set! f 1)
                  (set! p #\])))
      (if (char=? (string-ref input i) pr) (if (char=? p pr) (if (null? f)
        (return #f) (set! f #f)) (return #f)))
      (if (char=? (string-ref input i) #\:) (return #t))
      (set! i (+ i 1))
      (if (> i (- n 1)) (return #f)) ) 
       )) ))
(define (rg p) (let ((i '()) (n '()))   ; set or sequence interval
     (call/cc (lambda (return)          ; argument p is either
     (set! n (string-length input))     ; #\} or #\]
     (set! i 0)
      (do ()
       (#f)
       (if (char=? (string-ref input i) p) (return #f))
       (if (and (char=? (string-ref input i) #\.)
                (char=? (string-ref input (+ i 1)) #\.)) (return #t))
       (set! i (+ i 1))
       (if (> i (- n 1)) (return #f)) ) 
      )) ))
(define (mp p) (let ((i '()) (n '()))    ; set or sequence construction
     (call/cc (lambda (return)           ; argument p is either
     (set! n (string-length input))      ; #\} or #\]
     (set! i 0)
      (do ()
       (#f)
       (if (char=? (string-ref input i) p) (return #f))
       (if (and (char=? (string-ref input i) #\-)
                (char=? (string-ref input (+ i 1)) #\>)) (return #t))
       (set! i (+ i 1))
       (if (> i (- n 1)) (return #f)) ) 
      )) ))
(define lookmpu (lambda () (let ((i '()) (n '()))  ; look for map update
  (call/cc (lambda (return)
     (set! n (string-length input))
     (set! i 0)
      (do ()
       (#f)
       (if (char=? (string-ref input i) #\]) (begin
        (set! i (+ i 1))
        (if (>= i (- n 1)) (return #f))
        (do ()
         ((not (char=? (string-ref input i) #\ )))
         (set! i (+ i 1)) )
        (if (char=? (string-ref input i) #\=) (return #t)
          (return #f) ) ))
        (set! i (+ i 1))
        (if (>= i (- n 1)) (return #f)) )
      )) )))
(display ".")
(define lookrcu (lambda () (let ((i '()) (n '()))   ; look for record update
  (call/cc (lambda (return)
   (set! n (string-length input))
   (set! i 0)
   (do ()                                          
    (#f)
    (if (char=? (string-ref input i) #\.) (begin
     (set! i (+ i 1))
     (if (>= i (- n 1)) (return #f))
     (do ()
      ((not (char=? (string-ref input i) #\ )))
      (set! i (+ i 1)) )
     (do ()
      ((not (or (both-case-p (string-ref input i))
       (char=? (string-ref input i) #\_))))
      (set! i (+ i 1)) )
     (do ()
      ((not (char=? (string-ref input i) #\ )))
      (set! i (+ i 1)) ) 
     (if (>= i (- n 1)) (return #f))
     (if (and (char=? (string-ref input i) #\=)
              (not (char=? (string-ref input (+ i 1)) #\=)))
       (return #t) (return #f) ) ))
     (set! i (+ i 1))
     (if (>= i (- n 1)) (return #f)) ) 
      )) )))
(display ".")
(define factor (lambda () (let ((target '()) (target2 '())
  (target3 '()) (target4 '()) (target5 '()) (target6 '()) (ch '())
   (token '()) (u '()) (v '()) (w '())) (call/cc (lambda (return)
 (if (number? word) (begin (set! token word)                      ; number
   (set! word (next)) (return token)))
 (if (equal? word '@new) (begin
  (set! word (next))
  (set! target word)                 ; name of class
  (set! word (next))
  (if (not (equal? word "(")) (err4))
  (set! word (next))
  (if (equal? word ")") (begin       
  (set! target2 '())  ) (begin       
  (set! target2 (arglistu))
  (set! target2 (map (lambda (x) (if (and (pair? x) (procedure? (car x)))
  (eval x) x)) target2)) ))          
  (if (not (equal? word ")")) (err4))
  (set! word (next))
  (set! target3 (cons target target2))
  (if (not (null? target2))
   (return (eval `(cond 
           ((pair? ,target) (apply vector (cons (quote ,target)
                            (quote ,target2))))
           (else (,target ,@target2))))) )
  (return (eval `(cond 
          ((pair? ,target) (apply vector (cons (quote ,target)
                            (quote ,target2))))
 (else (begin (set! target3 (gensym))    
(set! target2 (,target)) 
(set! target3 (target2 ',target))
(target3)
target2)) ))) ))              
 (set! target (unop))                                 ; unop factor
 (if (not (isfalse target)) (begin
  (set! target2 (factor))
  (if (isfalse target2) (err4))
  (return (target target2)) ))
 (if (equal? word "$") (begin                        
  (set! ch (string-ref input 0))
  (set! word (string ch))
  (do ()
   ((not (char=? ch #\ )))
   (rdnext)
   (set! ch (nextchar)) )
  (rdnext)
  (set! ch (nextchar))
   (do ()
    ((not (or (both-case-p ch)
     (digit-char-p ch) (char=? ch #\_) (char=? ch #\-))))
    (set! word (string-append word (string ch)))
    (rdnext)
    (set! ch (nextchar)) )
  (set! word (string->symbol word))
  (set! target word)
  (set! word (next))                                
  (if (not (equal? word "(")) (begin                
   (return (eval target)) ))                        
  (set! word (next))
  (if (equal? word ")") (begin
   (set! word (next))
   (return (eval (cons target '())))))
  (set! target2 (arglistu))                        
  (if (not (equal? word ")")) (err4))              
  (set! word (next))                               
   (return (eval (cons target target2))) ))        
 (if (symbol? word) (begin
  (if (lookahead #\() (begin
   (set! target word)
   (set! word (next))
   (set! word (next))
   (if (equal? word ")") (set! target2 '())
   (set! target2 (arglistu)) )                  ; function call
   (if (not (equal? word ")")) (err4))
   (set! word (next))
  (return (eval (cons target target2))) ))   
  (set! token word)
  (set! word (next))
  (if (equal? word "[") (begin                          ; sequence
   (set! word (next))                                   ; selection or
   (set! target (simple))                               ; map application
   (if (equal? word ",") (begin
   (set! word (next))
   (set! target2 (expr))
   (if (isfalse target2) (err4))
   (if (not (equal? word "]")) (err4))
   (set! word (next))
   (if (string? (eval token)) (if (or (< target 1)
     (> target (string-length (eval token)))) (return target2)
     (return (substring (eval token) (- target 1) target))))
   (if (and (isset (eval token)) (null? (cdr (eval token))))
       (return target2))
   (if (ismap (eval token))
(return (appd (cdr (eval token)) target target2))     ; default value
    (return (seld (cdr (eval token)) target target2)) )))
   (if (not (equal? word "]")) (err4))
   (set! word (next))
   (if (string? (eval token)) (if (or (< target 1)
     (> target (string-length (eval token)))) (return 'false)
     (return (substring (eval token) (- target 1) target))))
   (if (ismap (eval token))
(return (app (cdr (eval token)) target))          ; no default value
    (return (sel (cdr (eval token)) target)) )))
(if (equal? word ".") (begin
  (set! word (next))
  (set! target2 word)
  (set! word (next))
  (if (vector? (eval token)) (begin
   (set! target3 (vector-ref (eval token) 0))
   (set! target3 (lookrec target2 (eval target3)))
   (return (vector-ref (eval token) target3)) ))
  (if (equal? word "(") (begin
   (set! word (next))
   (if (equal? word ")") (begin
     (set! word (next))
     (set! target3 '()))   (begin
   (set! target3 (arglist))
   (if (isfalse target3) (err4))
   (if (not (equal? word ")")) (err4))
   (set! word (next)) )) ))
   (set! target4 ((eval token) target2))
 (return (eval (cons (cons token (list (list 'quote target2)))
  target3))) ))
   (return (val-of token)) ))                      
 (if (equal? word "(") (begin                          ; (
  (set! word (next))
  (if (equal? word '@all) (begin                        ; universal quant.
   (set! word (next))
   (if (not (symbol? word)) (err4))
   (set! target word)
   (set! word (next))
   (if (not (equal? word '@in)) (err4))
   (set! word (next))
   (set! target2 (expr))
   (if (isfalse target2) (err4))
   (if (not (equal? word ";")) (err4))
   (set! word (next))
   (set! target3 (expru))
   (if (not (equal? word ")")) (err4))
   (set! word (next))
   (return (call/cc (lambda (return) (let ((u '()))
         (set! u (cdr target2))
          (do ()
           (#f)
           (if (null? u) (return #t))
           (eval `(set! ,target ,(car u)))
           (if (not (eval target3)) (return #f))
           (set! u (cdr u)) ) 
          )) )) ))
   (if (equal? word '@exists) (begin                    ; existential quant.
    (set! word (next))
    (if (not (symbol? word)) (err4))
    (set! target word)
    (set! word (next))
    (if (not (equal? word '@in)) (err4))
    (set! word (next))
    (set! target2 (expr))
    (if (not (equal? word ";")) (err4))
    (set! word (next))
    (set! target3 (expru))
    (if (not (equal? word ")")) (err4))
    (set! word (next))
    (return (call/cc (lambda (return) (let ((u '()))
          (set! u (cdr target2))
           (do ()
            (#f)
            (if (null? u) (return #f))
            (eval `(set! ,target ,(car u)))
            (if (eval target3) (return #t))
            (set! u (cdr u)) ) 
           )) )) ))
  (set! target (expr))                            
  (if (isfalse target) (err4))
  (if (not (equal? word ")")) (err4))                ;  )
  (set! word (next))
  (return target) ))
 (if (equal? word "{") (begin
  (set! word (next))
  (if (equal? word "}") (begin
   (set! word (next))
  (return (mkset '())) ))                               ; empty set or map
 (if (sc #\}) (begin
  (set! target (expru))
  (if (isfalse target) (err4))
  (if (equal? word "->") (begin
    (set! word (next))
    (set! target2 (expru))
    (if (not (equal? word ":")) (err4))
    (set! word (next))
    (set! target3 (expru))
    (if (not (equal? word "<-")) (err4))
    (set! word (next))
    (set! target4 (expr))
    (if (isfalse target4) (err4))
    (if (equal? word "}") (begin
      (set! word (next))
      (set! u (cdr target4))
       (do ()
        ((null? u))
        (eval `(set! ,target3 ,(car u)))
        (set! v (append v (list (list (eval target)
          (eval target2)))))
        (set! u (cdr u)) )
  (return (mkmap v)) ))
  (if (not (equal? word ";")) (err4))
  (set! word (next))
  (set! target5 (expru))
  (if (isfalse target5) (err4))
  (if (not (equal? word "}")) (err4))
  (set! word (next))
  (set! u (cdr target4))
   (do ()
    ((null? u))
    (eval `(set! ,target3 ,(car u)))
    (if (eval target5) (set! v (append v (list (list
      (eval target) (eval target2))))))
    (set! u (cdr u)) )  
  (return (mkmap v)) ))
  (set! word (next))
  (set! target2 (expru))
  (if (not (equal? word "<-")) (err4))               ; set comprehension
  (set! word (next))
  (set! target3 (expr))
  (if (isfalse target3) (err4))
  (if (equal? word "}") (begin (set! word (next))
  (set! u (cdr target3))
   (do ()
    ((null? u))
    (eval `(set! ,target2 ',(car u)))
    (set! v (append v (list (eval target))))
    (set! u (cdr u)) )
(return (mkset (elimdup v))) ))                    ; a map
  (if (equal? word ",") (begin
    (set! word (next))
    (set! target4 word)
    (set! word (next))
    (if (not (equal? word "<-")) (err4))
    (set! word (next))
    (set! target5 (expr))
    (if (isfalse target5) (err4))
    (if (equal? word "}") (begin
      (set! word (next))
      (set! u (cdr target3))
      (do ()
       ((null? u))
       (eval `(set! ,target2 ',(car u)))
       (set! w (cdr target5))
       (do ()
        ((null? w))
        (eval `(set! ,target4 ',(car w)))
        (set! v (append v (list (eval target))))
        (set! w (cdr w)) )
       (set! u (cdr u)) )
(return (mkset (elimdup v))) ))
    (if (not (equal? word ";")) (err4))
    (set! word (next))
    (set! target6 (expru))
    (if (isfalse target6) (err4))
    (if (not (equal? word "}")) (err4))
    (set! word (next))
    (set! u (cdr target3))
    (do ()
     ((null? u))
     (eval `(set! ,target2 ',(car u)))
     (set! w (cdr target5))
     (do ()
      ((null? w))
      (eval `(set! ,target4 ',(car w)))
      (if (eval target6) (set! v (append v (list (eval target)))))
      (set! w (cdr w)) )
     (set! u (cdr u)) )
(return (mkset (elimdup v))) ))
  (if (not (equal? word ";")) (err4))
  (set! word (next))
  (set! target4 (expru))
  (if (isfalse target4) (err4))
  (if (not (equal? word "}")) (err4))
  (set! word (next))
  (set! u (cdr target3))
   (do ()
    ((null? u))
    (eval `(set! ,target2 ',(car u)))
    (if (eval target4) (set! v (append v (list (eval target)))))
    (set! u (cdr u)) )
    (return (mkset v)) ))
 (if (mp #\}) (begin                                  ; map enumeration
  (set! target (pairlist))
  (if (isfalse target) (err4))
  (if (not (equal? word "}")) (err4))
  (set! word (next))
  (return (mkmap target)) ))
 (if (rg #\}) (begin
  (set! target (simple))
  (if (isfalse target) (err4))
  (if (not (equal? word "..")) (err 74))                ; set interval 
  (set! word (next))
  (set! target2 (simple))
  (if (isfalse target2) (err4))
  (if (not (equal? word "}")) (err4))
  (set! word (next))
  (return (itokset target target2)) ))
  (set! target (arglist))                              ; set enumeration
  (if (isfalse target) (err4))
   (if (not (equal? word "}")) (err4))
   (set! word (next))
   (return (mkset target)) ))
 (if (equal? word "[") (begin
  (set! word (next))
  (if (equal? word "]") (begin
   (set! word (next))
   (return (mkseq '())) ))                                  ; empty sequence
 (if (sc #\]) (begin
  (set! target (expru))
  (if (isfalse target) (err4))
  (set! word (next))
  (set! target2 (expru))
  (if (isfalse target2) (err4))
  (if (not (equal? word "<-")) (err4))               ; seq comprehension
  (set! word (next))
  (set! target3 (expr))
  (if (isfalse target3) (err4))
  (if (equal? word "]") (begin (set! word (next))
  (set! u (cdr target3))
   (do ()
    ((null? u))
    (eval `(set! ,target2 ,(car u)))
    (set! v (append v (list (eval target))))
    (set! u (cdr u)) )
   (return (mkseq v)) ))
 (if (equal? word ",") (begin
  (set! word (next))
  (set! target4 word)
  (set! word (next))
  (if (not (equal? word "<-")) (err4))
  (set! word (next))
  (set! target5 (expr))
  (if (isfalse target5) (err4))
  (if (equal? word "]") (begin
   (set! word (next))
   (set! u (cdr target3))
   (do ()
    ((null? u))
    (eval `(set! ,target2 ,(car u)))
    (set! w (cdr target5))
    (do ()
     ((null? w))
     (eval `(set! ,target4 ,(car w)))
     (set! v (append v (list (eval target))))
     (set! w (cdr w)) )
    (set! u (cdr u)) )
(return (mkseq v)) ))
 (if (not (equal? word ";")) (err4))
    (set! word (next))
    (set! target6 (expru))
    (if (isfalse target6) (err4))
    (if (not (equal? word "]")) (err4))
    (set! word (next))
    (set! u (cdr target3))
    (do ()
     ((null? u))
     (eval `(set! ,target2 ,(car u)))
     (set! w (cdr target5))
     (do ()
      ((null? w))
      (eval `(set! target4 ,(car w)))
      (if (eval target6) (set! v (append v (list (eval target)))))
      (set! w (cdr w)) )
     (set! u (cdr u)) )
 (return (mkseq v)) ))
 (if (not (equal? word ";")) (err4))
  (set! word (next))
  (set! target4 (expru))
  (if (isfalse target4) (err4))
  (if (not (equal? word "]")) (err4))
  (set! word (next))
  (set! u (cdr target3))
  (do ()
   ((null? u))
   (eval `(set! ,target2 ,(car u)))
   (if (eval target4) (set! v (append v (list (eval target)))))
   (set! u (cdr u)) )
  (return (mkseq v)) ))
 (if (rg #\]) (begin
  (set! target (simple))
  (if (isfalse target) (err4))
  (if (not (equal? word "..")) (err4))                ; seq interval
  (set! word (next))
  (set! target2 (simple))
  (if (isfalse target2) (err4))
  (if (not (equal? word "]")) (err4))
  (set! word (next))
  (return (itokseq target target2)) ))
  (set! target (arglist))                              ; seq enumeration
  (if (isfalse target) (err4))
   (if (not (equal? word "]")) (err4))
   (set! word (next))
   (return (mkseq target)) ))
(if (string? word) (begin (set! token word)            ; string
  (set! word (next)) (return token)))
 (return '$false) )) )))
(define unop (lambda () (call/cc (lambda (return)            ; unop
 (if (equal? word "!") (set! word 'not))
 (if (symbol? word)
   (cond ((equal? word 'not) (set! word (next)) (return not))
         ((equal? word '@dom) (set! word (next)) (return dom))
         ((equal? word '@rng) (set! word (next)) (return rng))
         ((equal? word '@union) (set! word (next)) (return dunion))
         ((equal? word '@hd) (set! word (next)) (return hd))
         ((equal? word '@tl) (set! word (next)) (return tl))
         ((equal? word '@last) (set! word (next)) (return last))
         ((equal? word '@butlast) (set! word (next)) (return butlast))
         ((equal? word '@card) (set! word (next)) (return card))
         ((equal? word '@len) (set! word (next)) (return len))
         ((equal? word '@the) (set! word (next)) (return the))
         ((equal? word '@inverse) (set! word (next)) (return inverse))
         ((equal? word '@first) (set! word (next)) (return first))
         ((equal? word '@second) (set! word (next)) (return second))
         ((equal? word '@map2seq) (set! word (next)) (return asq))
         ((equal? word '@seq2map) (set! word (next)) (return asm))
         ((equal? word '@oneof) (set! word (next)) (return oneof))
         ((equal? word '@is_number) (set! word (next)) (return number?))
         ((equal? word '@is_boolean) (set! word (next)) (return boolean?))
         ((equal? word '@is_string) (set! word (next)) (return string?))
         ((equal? word '@is_set) (set! word (next)) (return isset))
         ((equal? word '@is_map) (set! word (next)) (return ismap))
         ((equal? word '@is_seq) (set! word (next)) (return isseq))
         ((equal? word '@is_struct) (set! word (next)) (return vector?))
         ((equal? word '@is_object) (set! word (next)) (return procedure?))
         (else (return '$false))))
 (if (equal? word "-") (begin (set! word (next)) (return -)))
 (if (equal? word "+") (begin (set! word (next)) (return +)))
 (return '$false) )) ))
(define unopu (lambda () (call/cc (lambda (return)            ; unop
 (if (equal? word "!") (set! word 'not))
 (if (symbol? word)
   (cond ((equal? word 'not) (set! word (next)) (return 'not))
         ((equal? word '@dom) (set! word (next)) (return 'dom))
         ((equal? word '@rng) (set! word (next)) (return 'rng))
         ((equal? word '@union) (set! word (next)) (return 'dunion))
         ((equal? word '@hd) (set! word (next)) (return 'hd))
         ((equal? word '@tl) (set! word (next)) (return 'tl))
         ((equal? word '@last) (set! word (next)) (return 'last))
         ((equal? word '@butlast) (set! word (next)) (return 'butlast))
         ((equal? word '@card) (set! word (next)) (return 'card))
         ((equal? word '@len) (set! word (next)) (return 'len))
         ((equal? word '@the) (set! word (next)) (return 'the))
         ((equal? word '@inverse) (set! word (next)) (return 'inverse))
         ((equal? word '@first) (set! word (next)) (return 'first))
         ((equal? word '@second) (set! word (next)) (return 'second))
         ((equal? word '@map2seq) (set! word (next)) (return 'asq))
         ((equal? word '@seq2map) (set! word (next)) (return 'asm))
         ((equal? word '@oneof) (set! word (next)) (return 'oneof))
         ((equal? word '@is_number) (set! word (next)) (return 'number?))
         ((equal? word '@is_boolean) (set! word (next)) (return 'boolean?))
         ((equal? word '@is_string) (set! word (next)) (return 'string?))
         ((equal? word '@is_set) (set! word (next)) (return 'isset))
         ((equal? word '@is_map) (set! word (next)) (return 'ismap))
         ((equal? word '@is_seq) (set! word (next)) (return 'isseq))
         ((equal? word '@is_struct) (set! word (next)) (return 'vector?))
         ((equal? word '@is_object) (set! word (next)) (return 'procedure?))
         (else (return '$false))))
 (if (equal? word "-") (begin (set! word (next)) (return '-)))
 (if (equal? word "+") (begin (set! word (next)) (return '+)))
 (return '$false) )) ))
(define (conj x y) (and x y))
(define (disj x y) (or x y))
(define arglist (lambda () (let ((target '()) (target2 '()) (ls '()))
 (call/cc (lambda (return)
 (set! target (simple))
 (if (isfalse target) (return ls))
 (set! ls (append ls (unit target)))
  (do ()
   ((not (equal? word ",")))
   (set! word (next))
   (set! target2 (simple))
   (if (isfalse target2) (err4))
   (set! ls (append ls (unit target2))) )
 (return ls) )) )))
(define arglistu (lambda () (let ((target '()) (target2 '()) (ls '()))
 (call/cc (lambda (return)
 (set! target (simpleu))
 (if (isfalse target) (return ls))
 (set! ls (append ls (unit target)))
  (do ()
   ((not (equal? word ",")))
   (set! word (next))
   (set! target2 (simpleu))
   (if (isfalse target2) (err4))
   (set! ls (append ls (unit target2))) )
 (return ls) )) )))
(display ".")
(define expru (lambda () (let ((target '()) (target2 '()) (target3 '()))
 (call/cc (lambda (return)
   (set! target (simpleu))
   (if (isfalse target) (return '$false))
   (set! target2 (relopu))
   (if (isfalse target2) (return target))
   (set! target3 (simpleu))
   (if (isfalse target3) (err4))
   (return (call/cc (lambda (return); (if (and (string? target)
                                    ;          (string? target3))
   (case target2 ('< (set! target2 'lt))
                 ('> (set! target2 'gt))
                 ('equal (set! target2 'eq))
                 ('<= (set! target2 'le))
                 ('>= (set! target2 'ge))
                 ('neq (set! target2 'ne)) )  
            (return `(,target2 ,target ,target3))))) )) )))
(define simpleu (lambda () (let ((target '()) (target2 '()) (op '()))
 (call/cc (lambda (return)
 (set! target (termu))
 (if (isfalse target) (return '$false))
 (set! op (addopu))
  (do ()
   ((not op))
   (set! target2 (termu))
   (if (isfalse target2) (err4))
   (if (equal? op 'disj) (set! target `(or ,target ,target2))
   (set! target `(,op ,target ,target2)))
   (set! op (addopu)) )
(return target) )) )))
(display ".")
(define termu (lambda () (let ((target '()) (target2 '()) (op '()))
 (call/cc (lambda (return)
 (set! target (factoru))
 (set! op (mulopu))
  (do ()
   ((not op))
   (set! target2 (factoru))
   (if (isfalse target2) (err4))
   (if (equal? op 'conj) (set! target `(and ,target ,target2))
     (set! target `(,op ,target ,target2)))
   (set! op (mulopu)) )
 (return target) )) )))
(define factoru (lambda () (let ((target '()) (target2 '()) (target3 '())
   (target4 '()) (target5 '()) (target6 '()) (token '()) 
   (ch '()) (u '()) (v '()))
   (call/cc (lambda (return)
 (if (number? word) (begin (set! token word)          ; number
   (set! word (next)) (return token)))
 (if (equal? word '@new) (begin
  (set! word (next))
  (set! target word)                 ; name of class
  (set! word (next))
  (if (not (equal? word "(")) (err4))
  (set! word (next))
  (if (equal? word ")") (begin
  (set! target2 '()) ) (begin
  (set! target2 (arglistu)) ))
  (if (not (equal? word ")")) (err4))
  (set! word (next))
  (if (not (null? target2))
   (return `(cond 
    ((pair? ,target) (vector ,target ,@target2))
                 (else (,target ,@target2)))) )
   (return `(cond 
                 ((pair? ,target) (apply vector (cons ,target
                    ,target2)))
                 (else (begin (set! target3 (gensym))
                 (eval `(set! ,target3 (,target ,@target2)))
                 (((eval target3) ',target))
                 (eval target3)) ))) ))
 (if (equal? word '@open) (begin
   (set! word (next))
   (if (not (equal? word "(")) (err 1))
   (set! target (next))
   (set! word (next))
   (if (not (equal? word ",")) (err 2))
   (set! target2 (next))
   (set! word (next))
   (if (not (equal? word ")")) (err 3))
   (set! word (next))
   (cond ((equal? target2 "r")
    (return `(call/cc (lambda (return)
    (return (open-input-file ,target))))))
         ((equal? target2 "w")
   (return `(call/cc (lambda (return)
     (return (open-output-file ,target))))))
         ((equal? target2 "s")
     (return (list 'file2str target)))
   (else (err 37))) ))
 (if (equal? word "$") (begin                       
  (set! ch (string-ref input 0))
  (set! word (string ch))
  (do ()
   ((not (char=? ch #\ )))
   (rdnext)
   (set! ch (nextchar)) ) 
  (rdnext)
  (set! ch (nextchar))
   (do ()
    ((not (or (both-case-p ch)
    (digit-char-p ch) (char=? ch #\_) (char=? ch #\-))))
    (set! word (string-append word (string ch)))
    (rdnext)
    (set! ch (nextchar)) )
  (set! word (string->symbol word))
  (set! target word)
  (set! word (next))                               
  (if (not (equal? word "(")) (begin              
   (return target) ))                            
  (set! word (next))
  (if (equal? word ")") (begin
   (set! word (next))
   (return (cons target '()))))
  (set! target2 (arglistu))                       
  (if (not (equal? word ")")) (err4))            
  (set! word (next))                            
  (return (cons target target2)) ))            
 (set! target (unopu))                                 ; unop factor
 (if (not (isfalse target)) (begin
  (set! target2 (factoru))
  (if (isfalse target2) (err4))
  (return (list target target2)) ))
 (if (symbol? word) (begin
  (if (lookahead #\() (begin
   (set! target word)
   (set! word (next))
   (set! word (next))
   (if (equal? word ")") (set! target2 '())
   (set! target2 (arglistu)) )                              ; function call
   (if (not (equal? word ")")) (err4))
   (set! word (next))
   (return (cons target target2)) ))
 (set! token word)
  (set! word (next))
  (if (equal? word "[") (begin                             ; sequence
   (set! word (next))                                      ; selection or
   (set! target (simpleu))                                  ; map application
   (if (isfalse target) (err4))
   (if (equal? word ",") (begin
   (set! word (next))
   (set! target2 (expru))
   (if (isfalse target2) (err4))
   (if (not (equal? word "]")) (err4))
   (set! word (next))
   (return `(cond ((string? ,token) (if (or (< ,target 1)
                    (> ,target (string-length ,token))) ,target2))
                  ((and (isset ,token) (null? (cdr ,token))) ,target2)
                  ((ismap ,token) (appd (cdr ,token) ,target ,target2))
                  (else (seld (cdr ,token) ,target ,target2)))) ))
   (if (not (equal? word "]")) (err4))
   (set! word (next))
   (return `(cond ((string? ,token) (if (or (< ,target 1)
                    (> ,target (string-length ,token)))
                    #f (substring ,token (- ,target 1) ,target)))
                  ((ismap ,token) (app (cdr ,token), target))
                  (else (sel (cdr ,token) ,target)))) ))
   (if (equal? word ".") (begin
  (set! word (next))
  (set! target2 word)
  (set! word (next))
  (if (equal? word "(") (begin
    (set! word (next))
    (if (equal? word ")") (begin
      (set! word (next))
      (set! target3 '())) (begin
    (set! target3 (arglistu))
    (if (isfalse target3) (err4))
    (if (not (equal? word ")")) (err4))
    (set! word (next)) )) ))
 (return `(call/cc (lambda (return)
 (if (vector? ,token) (return (vector-ref ,token (lookrec (quote ,target2)
       (eval (vector-ref ,token 0)))))) 
  (return ((,token (quote ,target2)) ,@target3)) )) )) )
   (return token) ))                                   ; identifier
 (if (equal? word "(") (begin                          ; (
  (set! word (next))
 (if (equal? word '@all) (begin                         ; universal quant.
   (set! word (next))
   (if (not (symbol? word)) (err4))
   (set! target word)
   (set! word (next))
   (if (not (equal? word '@in)) (err4))
   (set! word (next))
   (set! target2 (expru))
   (if (isfalse target2) (err4))
   (if (not (equal? word ";")) (err4))
   (set! word (next))
   (set! target3 (expru))
   (if (isfalse target3) (err4))
   (if (not (equal? word ")")) (err4))
   (set! word (next))
   (return `(call/cc (lambda (return) (let ((u '()))
       ; (define ,target)
         (set! u (cdr ,target2))
         (do ()
          (#f)
          (if (null? u) (return #t))
          (set! ,target (car u))
          (if (not (eval ,target3)) (return #f))
          (set! u (cdr u)) )  
        )) )) ))
   (if (equal? word '@exists) (begin                    ; existential quant.
    (set! word (next))
    (if (not (symbol? word)) (err4))
    (set! target word)
    (set! word (next))
    (if (not (equal? word '@in)) (err4))
    (set! word (next))
    (set! target2 (expru))
    (if (not (equal? word ";")) (err4))
    (set! word (next))
    (set! target3 (expru))
    (if (isfalse target3) (err4))
    (if (not (equal? word ")")) (err4))
    (set! word (next))
    (return `(call/cc (lambda (return) (let ((u '()))
          (set! u (cdr ,target2))
           (do ()
            (#f)
            (if (null? u) (return #f))
            (set! ,target (car u))
            (if (eval ,target3) (return #t))
            (set! u (cdr u)) ) 
           )) )) ))
  (set! target (expru))                             
  (if (isfalse target) (err4))
  (if (not (equal? word ")")) (err 117))                ;  )
  (set! word (next))
  (return target) ))
(if (equal? word "{") (begin
  (set! word (next))
  (if (equal? word "}") (begin
   (set! word (next))
  (return (list 'mkset (quote '()))) ))                 ; empty set or map
 (if (sc #\}) (begin
  (set! target (expru))
  (if (isfalse target) (err4))
  (if (equal? word "->") (begin
    (set! word (next))
    (set! target2 (expru))
    (if (not (equal? word ":")) (err4))
    (set! word (next))
    (set! target3 (expru))
    (if (not (equal? word "<-")) (err4))
    (set! word (next))
    (set! target4 (expru))
    (if (isfalse target4) (err4))
    (if (equal? word "}") (begin (set! word (next))
    (return `(call/cc (lambda (return)
     (let ((u '()) (v '()) (,target3 '()))
    (set! u (cdr ,target4))
    (do ()
     ((null? u))
     (set! ,target3 (car u))
     (set! v (append v (list (list ,target ,target2))))
     (set! u (cdr u)) ) 
  (return (mkmap v)))) )) ))
  (if (not (equal? word ";")) (err4))
  (set! word (next))
  (set! target5 (expru))
  (if (isfalse target5) (err4))
  (if (not (equal? word "}")) (err4))
  (set! word (next))
  (return `(call/cc (lambda (return)
   (let ((u '()) (v '()) (,target3 '()))
  (set! u (cdr ,target4))
   (do ()
    ((null? u))
    (set! ,target3 (car u))
    (if (eval ,target5) (set! v (append v (list (list
     ,target ,target2)))))
    (set! u (cdr u)) )
  (return (mkmap v)))) )) ))
  (set! word (next))
  (set! target2 (expru))
  (if (isfalse target2) (err4))
  (if (not (equal? word "<-")) (err4))               ; set comprehension
  (set! word (next))
  (set! target3 (expru))
  (if (equal? word "}") (begin (set! word (next))
 (return `(call/cc (lambda (return)
  (let ((u '()) (v '()) (,target2 '()))
 (set! u (cdr ,target3))
 (do ()
  ((null? u))
  (set! ,target2 (car u))
  (set! v (append v (list ,target)))
  (set! u (cdr u)) )
(return (mkset (elimdup v))))) )) ))
 (if (equal? word ",") (begin (set! word (next))
 (set! target4 word)
 (set! word (next))
 (if (not (equal? word "<-")) (err4))
 (set! word (next))
 (set! target5 (expru))
 (if (isfalse target5) (err4))
 (if (equal? word "}") (begin
 (set! word (next))
 (return `(call/cc (lambda (return)
  (let ((u '()) (v '()) (w '())
  (,target2 ) (,target4 '()))                                 
 (set! u (cdr ,target3))
  (do ()
   ((null? u))
   (set! ,target2 (car u))
   (set! w (cdr ,target5))
   (do ()
    ((null? w))
    (set! ,target4 (car w))
    (set! v (append v (list ,target)))
    (set! w (cdr w)) )
   (set! u (cdr u)) )
(return (mkset (elimdup v))) )) )) ))
(if (not (equal? word ";")) (err4))
(set! word (next))
(set! target6 (expru))
(if (isfalse target6) (err4))
(if (not (equal? word "}")) (err4))
(set! word (next))
(return `(call/cc (lambda (return) (let ((u '()) (v '()) (w '()))
(set! u (cdr ,target3))
  (do ()
   ((null? u))
   (set! ,target2 (car u))
   (set! w (cdr ,target5))
   (do ()
    ((null? w))
    (set! ,target4 (car w))
    (if ,target6 (set! v (append v (list ,target))))
    (set! w (cdr w)) )
   (set! u (cdr u)) )
(return (mkset (elimdup v))) )) )) ))
 (if (not (equal? word ";")) (err4))
  (set! word (next))
  (set! target4 (expru))
  (if (isfalse target4) (err4))
  (if (not (equal? word "}")) (err4))
  (set! word (next))
  (return `(call/cc (lambda (return) (let ((u '()) (v '()) (,target2 '()))
  (set! u (cdr ,target3))
  (do ()
   ((null? u))
   (set! ,target2 (car u))
   (if (eval ,target4) (set! v (append v (list , target))))
   (set! u (cdr u)) )
    (return (mkset v)) )) )) ))
 (if (mp #\}) (begin                                   ; map enumeration
  (set! target (pairlistu))
  (if (isfalse target) (err4))
  (if (not (equal? word "}")) (err4))
  (set! word (next))
  (set! target (cons 'list target))
  (return (list 'mkmap target)) ))
 (if (rg #\}) (begin
  (set! target (simpleu))
  (if (isfalse target) (err4))
  (if (not (equal? word "..")) (err4))                ; set interval 
  (set! word (next))
  (set! target2 (simpleu))
  (if (isfalse target2) (err4))
  (if (not (equal? word "}")) (err4))
  (set! word (next))
  (return `(itokset (eval ,target)
    (eval ,target2) )) ))
  (set! target (arglistu))                              ; set enumeration
  (if (isfalse target) (err4))
   (if (not (equal? word "}")) (err4))
   (set! word (next))
   (return (list 'mkset (cons 'list target))) ))
 (if (equal? word "[") (begin
  (set! word (next))
  (if (equal? word "]") (begin
   (set! word (next))
   (return (list 'mkseq (quote '()))) ))
 (if (sc #\]) (begin                                    ; empty sequence
  (set! target (expru))
  (if (isfalse target) (err4))
  (set! word (next))
  (set! target2 (expru))
  (if (not (equal? word "<-")) (err4))               ; seq comprehension
  (set! word (next))
  (set! target3 (expru))
  (if (isfalse target3) (err4))
  (if (equal? word "]") (begin (set! word (next))
 (return `(call/cc (lambda (return) (let ((u '()) (v '()) (,target2 '()))
 (set! u (cdr ,target3))
  (do ()
   ((null? u))
   (set! ,target2 (car u))
   (set! v (append v (list ,target)))
   (set! u (cdr u)) )
 (return (mkseq v)) )) )) ))
 (if (equal? word ",") (begin (set! word (next))                
 (set! target4 word)                                           
 (set! word (next))                                           
 (if (not (equal? word "<-")) (err4))                        
 (set! word (next))                                         
 (set! target5 (expru))                                    
 (if (isfalse target5) (err4))                            
 (if (equal? word "]") (begin                                   
 (set! word (next))                                              
 (return `(call/cc (lambda (return) (let ((u '()) (v '()) (w '())   
    (,target2 '()) (,target4 '()))                               
 (set! u (cdr ,target3))                                        
  (do ()
   ((null? u))
   (set! ,target2 (car u))
   (set! w (cdr ,target5))
   (do ()
    ((null? w))
    (set! ,target4 (car w))
    (set! v (append v (list ,target)))
    (set! w (cdr w)) )
   (set! u (cdr u)) ) 
  (return (mkseq v)) )) )) ))                                  
 (if (not (equal? word ";")) (err4))                          
 (set! word (next))                                          
 (set! target6 (expru))                                     
 (if (isfalse target6) (err4))                             
 (if (not (equal? word "]")) (err4))                      
 (set! word (next))                                      
 (return `(call/cc (lambda (return) (let ((u '()) (v '()) (w '())  
   (,target2 '()) (,target4 '()))                               
 (set! u (cdr ,target3))                                        
  (do ()
   ((null? u))
   (set! ,target2 (car u))
   (set! w (cdr ,target5))
   (do ()
    ((null? w))
    (set! ,target4 (car w))
    (if ,target6 (set! v (append v (list ,target))))
    (set! w (cdr w)) )
   (set! u (cdr u)) )
 (return (mkseq v)) )) )) ))                                   
 (if (not (equal? word ";")) (err4))
  (set! word (next))
  (set! target4 (expru))
  (if (isfalse target4) (err4))
  (if (not (equal? word "]")) (err4))
  (set! word (next))
  (return `(call/cc (lambda (return)
   (let ((u '()) (v '()) (,target2 '()))
  (set! u (cdr ,target3))
   (do ()
    ((null? u))
    (set! ,target2 (car u))
    (if (eval ,target4) (set! v (append v (list ,target))))
    (set! u (cdr u)) )
  (return (mkseq v)) )) )) ))
 (if (rg #\]) (begin
  (set! target (simpleu))
  (if (isfalse target) (err4))
  (if (not (equal? word "..")) (err4))                ; seq interval
  (set! word (next))
  (set! target2 (simpleu))
  (if (isfalse target2) (err4))
  (if (not (equal? word "]")) (err4))
  (set! word (next))
  (return `(itokseq (eval ,target)
    (eval ,target2) )) ))
  (set! target (arglistu))                              ; seq enumeration
  (if (isfalse target) (err4))
   (if (not (equal? word "]")) (err4))
   (set! word (next))
   (return (list 'mkseq (cons 'list target))) ))
(if (string? word) (begin (set! token word)           ; string
  (set! word (next)) (return token))
 (return '$false)) )) )))
